summaryrefslogtreecommitdiff
path: root/bin/encodevideo+loop+stream
diff options
context:
space:
mode:
authorJonas Smedegaard <dr@jones.dk>2017-04-16 14:43:57 +0200
committerJonas Smedegaard <dr@jones.dk>2017-04-16 15:41:44 +0200
commitebf683d88a96bdef264318f3cef165bd17dc6b72 (patch)
treedf69819a85b313ffe4507c119af221ebfd81435b /bin/encodevideo+loop+stream
parent3fac3065c98c26e97c21d3b4f22819a2cdcf8c38 (diff)
Fork encode+stream as encodevideo+loop+stream.
Diffstat (limited to 'bin/encodevideo+loop+stream')
-rwxr-xr-xbin/encodevideo+loop+stream29
1 files changed, 29 insertions, 0 deletions
diff --git a/bin/encodevideo+loop+stream b/bin/encodevideo+loop+stream
new file mode 100755
index 0000000..0decf10
--- /dev/null
+++ b/bin/encodevideo+loop+stream
@@ -0,0 +1,29 @@
+#!/bin/sh
+
+set -e
+
+HOST=${1:-morla}
+if [ "$HOST" = "$(hostname --short)" ]; then
+ IP=127.0.0.1
+else
+ IP=$(host "$HOST" | grep -Po 'address \K\S+')
+fi
+
+FIRSTPORT=${2:-5002} # even number - next 3 ports used too
+
+VBITRATE=500000
+
+TMPMOVIE=../tmp/omni/show0/earth.yuv
+
+# based on http://www.webmproject.org/docs/encoder-parameters/#real-time-cbr-encoding-and-streaming
+# + Drop frames, aggressively treat as static, and use fastest cpu
+ffmpeg -threads auto -re \
+ -stream_loop -1 -i "$TMPMOVIE" \
+ -an \
+ -codec:v vp8 -quality realtime -deadline realtime -cpu-used 15 \
+ -b:v "$VBITRATE" -minrate "$VBITRATE" -maxrate "$VBITRATE" \
+ -undershoot-pct 95 -bufsize $((6000*VBITRATE/1000)) -rc_init_occupancy $((4000*VBITRATE/1000)) \
+ -max-intra-rate 0 \
+ -qmin 4 -qmax 56 \
+ -static-thresh 500 -skip_threshold 50 \
+ -f rtp "rtp://$IP:$((FIRSTPORT+2))?pkt_size=1200"